entity fulladd8_tb is
end fulladd8_tb;

architecture behav of fulladd8_tb is
  component fulladd8
    port (i0, i1 : in bit_vector(7 downto 0);
          ci     : in bit;
          s      : out bit_vector(7 downto 0);
          co     : out bit);
  end component;

  signal i0_s, i1_s, s_s : bit_vector(7 downto 0);
  signal ci_s, co_s      : bit;
  
begin

  -- La prova esaustiva degli input possibili richiederebbe 256*256*2 passi.
  -- Meglio provare solo con un sottoinsieme di input. 
  
  uut: fulladd8 port map (i0_s, i1_s, ci_s, s_s, co_s);
  
  i0_p: process -- andamento del segnale i0_s
  begin
    i0_s <= "00000000";
    wait for 10 ns;
    i0_s <= "00000001";
    wait for 10 ns;
    i0_s <= "10000000";
    wait for 10 ns;
    i0_s <= "10001001";
    wait for 10 ns;
    i0_s <= "11111111";
    wait for 10 ns;
  end process;
  
  i1_p: process -- andamento del segnale i1_s
  begin
    i1_s <= "00000000";
    wait for 50 ns;
    i1_s <= "00000001";
    wait for 50 ns;
    i1_s <= "10000000";
    wait for 50 ns;
    i1_s <= "01111111";
    wait for 50 ns;
    i1_s <= "11111111";
    wait for 50 ns;
  end process;
  
  ci_p: process -- andamento del segnale ci_s
  begin
    ci_s <= '0';
    wait for 250 ns;
    ci_s <= '1';
    wait for 250 ns;
  end process;

end behav; 



